require.paths.unshift('./lib');

var util = require('util');
var validations = require('validations');
var _ = require('underscore')._;
var assert = require('assert');
var test_util = require('test-util');
var nodeunit = require('nodeunit');
    
module.exports = nodeunit.testCase({
  setUp: function(callback) {
    this.o = {};
    this.validation_config = {
      default_messages: {
        format: {
          pattern: '*{{name}} should match pattern {{compare_to}}.*'
        }
      },
      properties: {
        p: {
          format: {
            pattern: /foo/
          }
        }
      }
    };
    callback();
  },
  tearDown: function(callback) {
    callback();
  },
  
  'format': test_format
});

function test_format(test) {
  var errors, config = this.validation_config, 
      msg_tmpl = config.default_messages.format.pattern;

  test_util.test_val_should_error_tuples([
      [undefined, false], [null, false], [0, true], [1, true], ["a", true], 
      ["fo", true], ["foo", false], ["ffooo", false]
    ],
    test_util._test_should_error.call(this, test, config, 
      test_util.interp_s(msg_tmpl, {name: 'p', compare_to: config.properties.p.format.pattern})),
    test_util._test_should_not_error.call(this, test, config));
            
  test.done();
}